# search.py
# ---------
# Licensing Information:  You are free to use or extend these projects for 
# educational purposes provided that (1) you do not distribute or publish 
# solutions, (2) you retain this notice, and (3) you provide clear 
# attribution to UC Berkeley, including a link to 
# http://inst.eecs.berkeley.edu/~cs188/pacman/pacman.html
# 
# Attribution Information: The Pacman AI projects were developed at UC Berkeley.
# The core projects and autograders were primarily created by John DeNero 
# (denero@cs.berkeley.edu) and Dan Klein (klein@cs.berkeley.edu).
# Student side autograding was added by Brad Miller, Nick Hay, and 
# Pieter Abbeel (pabbeel@cs.berkeley.edu).


"""
In search.py, you will implement generic search algorithms which are called
by Pacman agents (in searchAgents.py).
"""
from game import Directions
from game import Agent
from game import Actions
import util

#####################################################
#                Tiny maze example                  #
#####################################################

def tinyMazeSearch(problem):
    """
    Returns a sequence of moves that solves tinyMaze.  For any other
    maze, the sequence of moves will be incorrect, so only use this for tinyMaze
    """
    from game import Directions
    s = Directions.SOUTH
    w = Directions.WEST
    return  [s,s,w,s,w,w,s,w]


#####################################################
#                  Question 1                       #
#####################################################

def depthFirstSearch(problem):
    """
    Search the deepest nodes in the search tree first

    Your search algorithm needs to return a list of actions that reaches
    the goal.  Make sure to implement a graph search algorithm

    To get started, you might want to try some of these simple commands to
    understand the search problem that is being passed in:

    print "Start:", problem.getStartState()
    print "Is the start a goal?", problem.isGoalState(problem.getStartState())
    print "Start's successors:", problem.getSuccessors(problem.getStartState())

    Note that get successors does not just, as its name suggests, returns successors.
    It actuall returns a list of triples (successor, action, stepCost).
    So to get, for example, the successor of the first successor, you can do something like:

    firstSuccessorList = problem.getSuccessors(problem.getStartState())
    firstSuccessor, firstAction, firstCost = firstSuccessorList[0]
    secondSuccessor = problem.getSuccessors(firstSuccessor)

    Note that, for this problem, the successor is just a Pacman position (x, y).
    IMPORTANT: this will not be the case once we start introducing heuristics,
    successors might be positions, list or pointers to objects your program
    knows nothing about. Do not assume anything about what a successor is!
    """
    "*** YOUR CODE HERE ***"
    util.raiseNotDefined()


#####################################################
#                  Question 2                       #
#####################################################

def breadthFirstSearch(problem):
    """
    Search the shallowest nodes in the search tree first.
    """
    "*** YOUR CODE HERE ***"
    util.raiseNotDefined()


#####################################################
#                  Question 3                       #
#####################################################

def uniformCostSearch(problem):
    "Search the node of least total cost first. "
    "*** YOUR CODE HERE ***"
    util.raiseNotDefined()


#####################################################
#                  Question 4                       #
#####################################################

class ApproximateSearchAgent(Agent):
    """
    Agent that should collect all food in the fewest number of steps possible,
    while all calculations should remain within the time-limit.
    Change anything but the class name.
     
    It is recommmended that you reuse your search algrotihms implemented above.
    To use one of your search algrotihms you'll need a search problem
    (see searchAgents.py for examples of search problems).
    For example, if you want to use the AnyFoodSearchProblem found in searchProblems.py
    you can do the following:
     
    from searchProblems import AnyFoodSearchProblem
    problem = AnyFoodSearchProblem(state)
    path = breadthFirstSearch(problem)
    """

    def registerInitialState(self, state):
        """"
         This method is called before any moves are made.
         You can do most of your searching here, and simply
         execute the move in getAction
        """
        "*** YOUR CODE HERE ***"
        util.raiseNotDefined()

    def getAction(self, state):
        """
        From game.py:
        The Agent will receive a GameState and must return an action from
        Directions.{North, South, East, West, Stop}
        """
        "*** YOUR CODE HERE ***"
        util.raiseNotDefined()


# Abbreviations
bfs = breadthFirstSearch
dfs = depthFirstSearch
ucs = uniformCostSearch
